Getting Started

TanStack Devtools Angular Adapter

The Angular adapter wraps TanStackDevtoolsCore in an Angular standalone component, using Angular's createComponent and ApplicationRef.attachView to dynamically render plugins into the correct DOM containers managed by the devtools shell.

Installation

sh
npm install @tanstack/angular-devtools
npm install @tanstack/angular-devtools

Component Inputs

The TanStackDevtools (selector: tanstack-devtools) accepts the following signal-based inputs, defined by the TanStackDevtoolsAngularInit interface:

InputTypeDescription
pluginsTanStackDevtoolsAngularPlugin[]Array of plugins to render inside the devtools panel.
configPartial<TanStackDevtoolsConfig>Configuration for the devtools shell. Sets the initial state on first load; afterwards settings are persisted in local storage.
eventBusConfigClientEventBusConfigConfiguration for the TanStack Devtools client event bus.

Plugin Type

Each plugin in the plugins array must conform to the TanStackDevtoolsAngularPlugin type:

ts
type TanStackDevtoolsAngularPlugin = {
  id?: string
  render: TanStackDevtoolsAngularPluginRender
  name: string | Type<any>
  inputs?: Record<string, any>
  defaultOpen?: boolean
}
type TanStackDevtoolsAngularPlugin = {
  id?: string
  render: TanStackDevtoolsAngularPluginRender
  name: string | Type<any>
  inputs?: Record<string, any>
  defaultOpen?: boolean
}
FieldTypeDescription
idstring (optional)Unique identifier for the plugin.
renderType<any>The Angular component class to render as the plugin panel content.
namestring | Type<any>Display name for the tab title. Can be a plain string or an Angular component class for custom rendering.
inputsRecord<string, any> (optional)Additional inputs passed to the plugin component via setInput().
defaultOpenboolean (optional)Whether this plugin tab should be open by default.

Key Differences from Other Frameworks

The Angular adapter uses component (an Angular component class reference) instead of render (a JSX element) in plugin definitions. Inputs are provided through the inputs field and bound to the component with setInput(), rather than being embedded directly in a JSX expression or passed via v-bind.

typescript
import { Component } from '@angular/core'
import { TanStackDevtools } from '@tanstack/angular-devtools'
import { AngularQueryDevtoolsPanel } from '@tanstack/angular-query-devtools'

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [TanStackDevtools],
  template: `
    <tanstack-devtools [plugins]="plugins" />
  `,
})
export class App {
  plugins = [
    {
      name: 'Angular Query',
      render: AngularQueryDevtoolsPanel,
      inputs: { style: 'height: 100%' },
    },
  ]
}
import { Component } from '@angular/core'
import { TanStackDevtools } from '@tanstack/angular-devtools'
import { AngularQueryDevtoolsPanel } from '@tanstack/angular-query-devtools'

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [TanStackDevtools],
  template: `
    <tanstack-devtools [plugins]="plugins" />
  `,
})
export class App {
  plugins = [
    {
      name: 'Angular Query',
      render: AngularQueryDevtoolsPanel,
      inputs: { style: 'height: 100%' },
    },
  ]
}

Exports

The @tanstack/angular-devtools package exports:

  • TanStackDevtools -- The main Angular standalone component that renders the devtools panel.
  • TanStackDevtoolsAngularPlugin (type) -- The type for plugin definitions.
  • TanStackDevtoolsAngularInit (type) -- The inputs interface for the TanStackDevtoolsComponent.

The package depends on @tanstack/devtools (the core package), which provides TanStackDevtoolsCore, TanStackDevtoolsConfig, ClientEventBusConfig, and other core utilities.

If you are using TanStack Devtools in a React application, we recommend using the React Adapter. The React Adapter provides a set of easy-to-use hooks on top of the core Devtools utilities. If you find yourself wanting to use the core Devtools classes/functions directly, the React Adapter will also re-export everything from the core package.
npm install @tanstack/react-devtoolsnpm install @tanstack/react-devtoolsThe main React component for rendering devtools. It accepts a single props object of type TanStackDevtoolsReactInit:
| Prop | Type | Description |
|---|---|---|
| plugins | TanStackDevtoolsReactPlugin[] | Array of plugins to display in the devtools panel |
| config | TanStackDevtoolsReactConfig | Devtools UI configuration (position, hotkeys, theme, custom trigger, etc.) |
| eventBusConfig | ClientEventBusConfig | Event bus connection settings for communicating with the server bus |
Each plugin describes a tab in the devtools panel:
type PluginRender =
| JSX.Element
| ((el: HTMLElement, theme: 'dark' | 'light') => JSX.Element)
type TanStackDevtoolsReactPlugin = {
id?: string
name: string | PluginRender
render: PluginRender
defaultOpen?: boolean
}type PluginRender =
| JSX.Element
| ((el: HTMLElement, theme: 'dark' | 'light') => JSX.Element)
type TanStackDevtoolsReactPlugin = {
id?: string
name: string | PluginRender
render: PluginRender
defaultOpen?: boolean
}import { TanStackDevtools } from '@tanstack/react-devtools'
import { ReactQueryDevtoolsPanel } from '@tanstack/react-query-devtools'
function App() {
return (
<>
<YourApp />
<TanStackDevtools
config={{ position: 'bottom-right', hideUntilHover: true }}
eventBusConfig={{ connectToServerBus: true }}
plugins={[
{
name: 'TanStack Query',
render: <ReactQueryDevtoolsPanel />,
defaultOpen: true,
},
]}
/>
</>
)
}import { TanStackDevtools } from '@tanstack/react-devtools'
import { ReactQueryDevtoolsPanel } from '@tanstack/react-query-devtools'
function App() {
return (
<>
<YourApp />
<TanStackDevtools
config={{ position: 'bottom-right', hideUntilHover: true }}
eventBusConfig={{ connectToServerBus: true }}
plugins={[
{
name: 'TanStack Query',
render: <ReactQueryDevtoolsPanel />,
defaultOpen: true,
},
]}
/>
</>
)
}The adapter includes a 'use client' directive at the top of its entry file, making it compatible with React Server Components. You can import it directly in your client components without needing to add your own 'use client' boundary.
The @tanstack/react-devtools package exports:

Getting Started

TanStack Devtools Vue Adapter

The Vue adapter wraps TanStackDevtoolsCore in a Vue 3 component, using Vue's <Teleport> to render plugins and their tab titles into the correct DOM containers managed by the devtools shell.

Installation

sh
npm install @tanstack/vue-devtools
npm install @tanstack/vue-devtools

Component Props

The TanStackDevtools component accepts the following props, defined by the TanStackDevtoolsVueInit interface:

PropTypeDescription
pluginsTanStackDevtoolsVuePlugin[]Array of plugins to render inside the devtools panel.
configPartial<TanStackDevtoolsConfig>Configuration for the devtools shell. Sets the initial state on first load; afterwards settings are persisted in local storage.
eventBusConfigClientEventBusConfigConfiguration for the TanStack Devtools client event bus.

Plugin Type

Each plugin in the plugins array must conform to the TanStackDevtoolsVuePlugin type:

ts
type TanStackDevtoolsVuePlugin = {
  id?: string
  component: Component
  name: string | Component
  props?: Record<string, any>
}
type TanStackDevtoolsVuePlugin = {
  id?: string
  component: Component
  name: string | Component
  props?: Record<string, any>
}
FieldTypeDescription
idstring (optional)Unique identifier for the plugin.
componentComponentThe Vue component to render as the plugin panel content.
namestring | ComponentDisplay name for the tab title. Can be a plain string or a Vue component for custom rendering.
propsRecord<string, any> (optional)Additional props passed to the plugin component via v-bind.

Key Difference from React

The Vue adapter uses component (a Vue component reference) instead of render (a JSX element) in plugin definitions. Props are provided through the props field and bound to the component with v-bind, rather than being embedded directly in a JSX expression.

vue
<!-- Vue: pass component reference + props -->
<script setup lang="ts">
import { TanStackDevtools } from '@tanstack/vue-devtools'
import { VueQueryDevtoolsPanel } from '@tanstack/vue-query-devtools'

const plugins = [
  {
    name: 'Vue Query',
    component: VueQueryDevtoolsPanel,
    props: { style: 'height: 100%' },
  },
]
</script>

<template>
  <TanStackDevtools :plugins="plugins" />
</template>
<!-- Vue: pass component reference + props -->
<script setup lang="ts">
import { TanStackDevtools } from '@tanstack/vue-devtools'
import { VueQueryDevtoolsPanel } from '@tanstack/vue-query-devtools'

const plugins = [
  {
    name: 'Vue Query',
    component: VueQueryDevtoolsPanel,
    props: { style: 'height: 100%' },
  },
]
</script>

<template>
  <TanStackDevtools :plugins="plugins" />
</template>

Exports

The @tanstack/vue-devtools package exports:

  • TanStackDevtools -- The main Vue component that renders the devtools panel.
  • TanStackDevtoolsVuePlugin (type) -- The type for plugin definitions.
  • TanStackDevtoolsVueInit (type) -- The props interface for the TanStackDevtools component.

The package depends on @tanstack/devtools (the core package), which provides TanStackDevtoolsCore, TanStackDevtoolsConfig, ClientEventBusConfig, and other core utilities.